(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue'), require('vue-prism-editor'), require('vue-property-decorator'), require('@zeedhi/zd-highlight-common'), require('@zeedhi/vuetify'), require('vue-prism-editor/dist/prismeditor.min.css')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue', 'vue-prism-editor', 'vue-property-decorator', '@zeedhi/zd-highlight-common', '@zeedhi/vuetify', 'vue-prism-editor/dist/prismeditor.min.css'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["@zeedhi/zd-highlight-vue"] = {}, global.vue, global["vue-prism-editor"], global["vue-property-decorator"], global["@zeedhi/zd-highlight-common"], global["@zeedhi/vuetify"]));
})(this, (function (exports, Vue, vuePrismEditor, vuePropertyDecorator, zdHighlightCommon, vuetify) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    let ZdHighlight = class ZdHighlight extends vuetify.ZdComponentRender {
        constructor() {
            super(...arguments);
            this.instanceType = zdHighlightCommon.Highlight;
        }
    };
    __decorate([
        vuePropertyDecorator.Prop({ type: String, default: '' }),
        __metadata("design:type", String)
    ], ZdHighlight.prototype, "code", void 0);
    __decorate([
        vuePropertyDecorator.Prop({ type: Boolean, default: false }),
        __metadata("design:type", Boolean)
    ], ZdHighlight.prototype, "readonly", void 0);
    __decorate([
        vuePropertyDecorator.Prop({ type: Boolean, default: false }),
        __metadata("design:type", Boolean)
    ], ZdHighlight.prototype, "lineNumbers", void 0);
    __decorate([
        vuePropertyDecorator.Prop({ type: Boolean, default: true }),
        __metadata("design:type", Boolean)
    ], ZdHighlight.prototype, "autoStyleLineNumbers", void 0);
    __decorate([
        vuePropertyDecorator.Prop({ type: [Number, String], default: 2 }),
        __metadata("design:type", Object)
    ], ZdHighlight.prototype, "tabSize", void 0);
    __decorate([
        vuePropertyDecorator.Prop({ type: Boolean, default: true }),
        __metadata("design:type", Boolean)
    ], ZdHighlight.prototype, "insertSpaces", void 0);
    __decorate([
        vuePropertyDecorator.Prop({ type: Boolean, default: false }),
        __metadata("design:type", Boolean)
    ], ZdHighlight.prototype, "ignoreTabKey", void 0);
    __decorate([
        vuePropertyDecorator.Prop({ type: String, default: 'ts' }),
        __metadata("design:type", String)
    ], ZdHighlight.prototype, "language", void 0);
    __decorate([
        vuePropertyDecorator.Prop({ type: String, default: 'none' }),
        __metadata("design:type", String)
    ], ZdHighlight.prototype, "maxHeight", void 0);
    __decorate([
        vuePropertyDecorator.Prop({ type: [String, Function], default: '' }),
        __metadata("design:type", Object)
    ], ZdHighlight.prototype, "loadExtraLanguages", void 0);
    ZdHighlight = __decorate([
        vuePropertyDecorator.Component
    ], ZdHighlight);
    var script = ZdHighlight;

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
        if (typeof shadowMode !== 'boolean') {
            createInjectorSSR = createInjector;
            createInjector = shadowMode;
            shadowMode = false;
        }
        // Vue.extend constructor export interop.
        const options = typeof script === 'function' ? script.options : script;
        // render functions
        if (template && template.render) {
            options.render = template.render;
            options.staticRenderFns = template.staticRenderFns;
            options._compiled = true;
            // functional template
            if (isFunctionalTemplate) {
                options.functional = true;
            }
        }
        // scopedId
        if (scopeId) {
            options._scopeId = scopeId;
        }
        let hook;
        if (moduleIdentifier) {
            // server build
            hook = function (context) {
                // 2.3 injection
                context =
                    context || // cached call
                        (this.$vnode && this.$vnode.ssrContext) || // stateful
                        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
                // 2.2 with runInNewContext: true
                if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                    context = __VUE_SSR_CONTEXT__;
                }
                // inject component styles
                if (style) {
                    style.call(this, createInjectorSSR(context));
                }
                // register component module identifier for async chunk inference
                if (context && context._registeredComponents) {
                    context._registeredComponents.add(moduleIdentifier);
                }
            };
            // used by ssr in case component is cached and beforeCreate
            // never gets called
            options._ssrRegister = hook;
        }
        else if (style) {
            hook = shadowMode
                ? function (context) {
                    style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
                }
                : function (context) {
                    style.call(this, createInjector(context));
                };
        }
        if (hook) {
            if (options.functional) {
                // register for functional component in vue file
                const originalRender = options.render;
                options.render = function renderWithStyleInjection(h, context) {
                    hook.call(context);
                    return originalRender(h, context);
                };
            }
            else {
                // inject component registration as beforeCreate hook
                const existing = options.beforeCreate;
                options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
            }
        }
        return script;
    }

    const isOldIE = typeof navigator !== 'undefined' &&
        /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
    function createInjector(context) {
        return (id, style) => addStyle(id, style);
    }
    let HEAD;
    const styles = {};
    function addStyle(id, css) {
        const group = isOldIE ? css.media || 'default' : id;
        const style = styles[group] || (styles[group] = { ids: new Set(), styles: [] });
        if (!style.ids.has(id)) {
            style.ids.add(id);
            let code = css.source;
            if (css.map) {
                // https://developer.chrome.com/devtools/docs/javascript-debugging
                // this makes source maps inside style tags work properly in Chrome
                code += '\n/*# sourceURL=' + css.map.sources[0] + ' */';
                // http://stackoverflow.com/a/26603875
                code +=
                    '\n/*# sourceMappingURL=data:application/json;base64,' +
                        btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) +
                        ' */';
            }
            if (!style.element) {
                style.element = document.createElement('style');
                style.element.type = 'text/css';
                if (css.media)
                    style.element.setAttribute('media', css.media);
                if (HEAD === undefined) {
                    HEAD = document.head || document.getElementsByTagName('head')[0];
                }
                HEAD.appendChild(style.element);
            }
            if ('styleSheet' in style.element) {
                style.styles.push(code);
                style.element.styleSheet.cssText = style.styles
                    .filter(Boolean)
                    .join('\n');
            }
            else {
                const index = style.ids.size - 1;
                const textNode = document.createTextNode(code);
                const nodes = style.element.childNodes;
                if (nodes[index])
                    style.element.removeChild(nodes[index]);
                if (nodes.length)
                    style.element.insertBefore(textNode, nodes[index]);
                else
                    style.element.appendChild(textNode);
            }
        }
    }

    /* script */
    const __vue_script__ = script;

    /* template */
    var __vue_render__ = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        {
          class: ["zd-highlight", _vm.instance.cssClass],
          style: _vm.instance.cssStyle
        },
        [
          _c("prism-editor", {
            staticClass: "zd-highlight-container",
            style: "max-height: " + (_vm.instance.maxHeight || "none"),
            attrs: {
              highlight: function() {
                return _vm.instance.getHighlightedCode()
              },
              readonly: _vm.instance.readonly,
              lineNumbers: _vm.instance.lineNumbers,
              autoStyleLineNumbers: _vm.instance.autoStyleLineNumbers,
              tabSize: _vm.instance.tabSize,
              insertSpaces: _vm.instance.insertSpaces,
              ignoreTabKey: _vm.instance.ignoreTabKey,
              language: _vm.instance.language
            },
            model: {
              value: _vm.instance.code,
              callback: function($$v) {
                _vm.$set(_vm.instance, "code", $$v);
              },
              expression: "instance.code"
            }
          })
        ],
        1
      )
    };
    var __vue_staticRenderFns__ = [];
    __vue_render__._withStripped = true;

      /* style */
      const __vue_inject_styles__ = function (inject) {
        if (!inject) return
        inject("data-v-0d0ab016_0", { source: ".zd-highlight .prism-editor-wrapper {\n  background-color: #f0f0f0;\n  font-family: Fira code, Fira Mono, Consolas, Menlo, Courier, monospace;\n  font-size: 14px;\n  line-height: 1.5;\n  padding: 5px 10px;\n}\n.zd-highlight .prism-editor-wrapper .prism-editor__editor,\n.zd-highlight .prism-editor-wrapper .prism-editor__textarea {\n  outline: none;\n}\n.zd-highlight-container {\n  position: relative;\n  min-height: 45px;\n  display: flex;\n  overflow: auto;\n}\n\n/*# sourceMappingURL=Highlight.vue.map */", map: {"version":3,"sources":["/Users/zedmartins/workfolder/zeedhi/highlight/packages/vue/src/Highlight.vue","Highlight.vue"],"names":[],"mappings":"AAwBA;EACA,yBAAA;EACA,sEAAA;EACA,eAAA;EACA,gBAAA;EACA,iBAAA;ACvBA;ADyBA;;EAEA,aAAA;ACvBA;AD2BA;EACA,kBAAA;EACA,gBAAA;EACA,aAAA;EACA,cAAA;ACzBA;;AAEA,wCAAwC","file":"Highlight.vue","sourcesContent":["<template>\n  <div\n    :class=\"['zd-highlight', instance.cssClass ]\"\n    :style=\"instance.cssStyle\"\n  >\n    <prism-editor\n      class=\"zd-highlight-container\"\n      :style=\"`max-height: ${(instance.maxHeight || 'none')}`\"\n      v-model=\"instance.code\"\n      :highlight=\"() => instance.getHighlightedCode()\"\n      :readonly=\"instance.readonly\"\n      :lineNumbers=\"instance.lineNumbers\"\n      :autoStyleLineNumbers=\"instance.autoStyleLineNumbers\"\n      :tabSize=\"instance.tabSize\"\n      :insertSpaces=\"instance.insertSpaces\"\n      :ignoreTabKey=\"instance.ignoreTabKey\"\n      :language=\"instance.language\"\n    >\n    </prism-editor>\n  </div>\n</template>\n\n<style lang=\"scss\">\n  .zd-highlight {\n    .prism-editor-wrapper {\n      background-color: #f0f0f0;\n      font-family: Fira code,Fira Mono,Consolas,Menlo,Courier,monospace;\n      font-size: 14px;\n      line-height: 1.5;\n      padding: 5px 10px;\n\n      .prism-editor__editor,\n        .prism-editor__textarea {\n        outline: none;\n      }\n    }\n\n    &-container {\n      position: relative;\n      min-height: 45px;\n      display: flex;\n      overflow: auto;\n    }\n  }\n</style>\n\n<script lang=\"ts\" src=\"./Highlight.ts\"></script>",".zd-highlight .prism-editor-wrapper {\n  background-color: #f0f0f0;\n  font-family: Fira code, Fira Mono, Consolas, Menlo, Courier, monospace;\n  font-size: 14px;\n  line-height: 1.5;\n  padding: 5px 10px;\n}\n.zd-highlight .prism-editor-wrapper .prism-editor__editor,\n.zd-highlight .prism-editor-wrapper .prism-editor__textarea {\n  outline: none;\n}\n.zd-highlight-container {\n  position: relative;\n  min-height: 45px;\n  display: flex;\n  overflow: auto;\n}\n\n/*# sourceMappingURL=Highlight.vue.map */"]}, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__ = undefined;
      /* module identifier */
      const __vue_module_identifier__ = undefined;
      /* functional template */
      const __vue_is_functional_template__ = false;
      /* style inject SSR */
      
      /* style inject shadow dom */
      

      
      const __vue_component__ = /*#__PURE__*/normalizeComponent(
        { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
        __vue_inject_styles__,
        __vue_script__,
        __vue_scope_id__,
        __vue_is_functional_template__,
        __vue_module_identifier__,
        false,
        createInjector,
        undefined,
        undefined
      );

    Vue__default["default"].component('PrismEditor', vuePrismEditor.PrismEditor);

    exports.ZdHighlight = __vue_component__;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
